﻿@model eCommerce.BackOffice.ViewModels.StockMovementListViewModel
@using eCommerce.Services.Model.Enums
@{
    ViewBag.Title = "Movimientos de Stock";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}

<div class="page-header">
    <h1 class="page-title">Movimientos de Stock</h1>
    <div class="page-header-actions">
        <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            <button type="button" class="btn btn-outline btn-primary" onclick="toggleModal('StockMovement')">
                <i class="icon wb-plus" aria-hidden="true"></i>
                <span class="hidden-xs">NUEVO MOVIMIENTO</span>
            </button>
        </div>
        <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            <button type="button" class="btn btn-outline btn-primary" onclick="toggleModal('StockExchange')">
                <i class="icon fa-exchange" aria-hidden="true"></i>
                <span class="hidden-xs">MOVIMIENTO ENTRE DEPÓSITOS</span>
            </button>
        </div>
    </div>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            @Html.Partial("_StockMovementList", Model.StockMovements)
        </div>
    </div>
</div>

<!--Stock Exchange-->
<div class="modal fade" id="StockExchange" aria-hidden="false" aria-labelledby="checks" role="dialog">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
                <h4 class="modal-title" id="exampleFormModalLabel">Movimiento de mercadería entre depósitos</h4>
            </div>
            <div class="modal-body">
                <form id="frmStockExchange">
                    @Html.Partial("_StockExchange", Model.StockExchange)
                </form>
            </div>
        </div>
    </div>
</div>

<!--Stock Movement-->
<div class="modal fade" id="StockMovement" aria-hidden="false" aria-labelledby="checks" role="dialog">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
                <h4 class="modal-title" id="exampleFormModalLabel">Nuevo movimiento de Stock</h4>
            </div>
            <div class="modal-body">
                <form id="frmStockMovement">
                    @Html.Partial("_StockMovement", Model.StockExchange)
                </form>
            </div>
        </div>
    </div>
</div>

<!-- End Modal -->
<style type="text/css">
    .select2-close-mask {
        z-index: 2099;
    }

    .select2-dropdown {
        z-index: 3051;
    }
</style>

@section Scripts {

    <script type="text/javascript">

        $(document).ready(function () {

            $('#frmStockExchange').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnSaveStockExhange'
                },
                icon: null,
                fields: {
                    OriginDepositId: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el depósito de orígen.'
                            }
                        }
                    },
                    DestinyDepositId: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el depósito destino.'
                            }
                        }
                    },
                    ProductId: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el producto.'
                            }
                        }
                    },
                    SizeId: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el talle.'
                            }
                        }
                    },
                    ColorId: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el color.'
                            }
                        }
                    },
                    Quantity: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese la cantidad.'
                            }
                        }
                    }
                }
            });

            $('#frmStockMovement').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnCreateStockMovement',
                    disabled: 'disabled'
                },
                icon: null,
                fields: {
                    MovementType: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el tipo de movimient de orígen.'
                            }
                        }
                    },
                    DepositId: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el depósito de orígen.'
                            }
                        }
                    },
                    ProductId_sm: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el producto.'
                            }
                        }
                    },
                    SizeId_sm: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el talle.'
                            }
                        }
                    },
                    ColorId_sm: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el color.'
                            }
                        }
                    },
                    Quantity_sm: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese la cantidad.'
                            }
                        }
                    },
                    Concept: {
                        validators: {
                            notEmpty: {
                                message: 'Ingrese el concepto.'
                            }
                        }
                    }
                }
            });

            $("#btnCreateStockMovement").click(function (e) {

                e.preventDefault();

                var frmStockMovement = $('#frmStockMovement').data('formValidation');
                frmStockMovement.validate();

                if (!frmStockMovement.isValid()) {
                    return;
                }

                var stockMovement =
                {
                    ProductId: null,
                    SizeId: null,
                    ColorId: null,
                    OriginDepositId: null,
                    MovementType: null,
                    Concept: null
                }

                stockMovement.MovementType = $('#MovementType').val();
                stockMovement.OriginDepositId = $('#DepositId').val();
                stockMovement.ProductId = $('#ProductId_sm').val();
                stockMovement.SizeId = $('#SizeId_sm').val();
                stockMovement.ColorId = $('#ColorId_sm').val();
                stockMovement.Quantity = $('#Quantity_sm').val();
                stockMovement.Concept = $('#Concept').val();

                $.ajax({
                    cache: false,
                    url: "/Products/CreateStockMovement",
                    data: { model: stockMovement },
                    datatype: "text",
                    method: "POST",
                    success: function (data)
                    {
                        toastr.success("El movimiento de stock se guardo correctamente.");

                        $('.panel-body').html(data);
                        $('.dataTable').DataTable();

                        toggleModal("StockMovement");
                        cleanFormInputs("frmStockMovement");
                    },
                    error: function (result) {
                        toastr.warning("Se produjo un error al intentar realizar el movimiento de stock.");
                    }
                });
            });

            $("#btnSaveStockExhange").click(function (e)
            {
                e.preventDefault();

                var frmStockExchange = $('#frmStockExchange').data('formValidation');
                frmStockExchange.validate();

                if (!frmStockExchange.isValid() || !isValidExchange()) {
                    return;
                }

                var stockEchange =
                {
                    ProductId: null,
                    SizeId: null,
                    ColorId: null,
                    OriginDepositId: null,
                    DestinyDepositId: null,
                    DestinyDepositName: null
                }

                stockEchange.ProductId = $('#ProductId').val();
                stockEchange.SizeId = $('#SizeId').val();
                stockEchange.ColorId = $('#ColorId').val();
                stockEchange.OriginDepositId = $('#OriginDepositId').val();
                stockEchange.DestinyDepositId = $('#DestinyDepositId').val();
                stockEchange.Quantity = $('#Quantity').val();

                $.ajax({
                    cache: false,
                    url: "/Products/StockExchange",
                    data: { model: stockEchange },
                    datatype: "text",
                    method: "POST",
                    success: function (data)
                    {
                        toastr.success("El movimiento entre depósitos se guardo correctamente.");

                        $('.panel-body').html(data);
                        $('.dataTable').DataTable();

                        toggleModal("StockExchange");
                        cleanFormInputs("frmStockExchange");
                    },
                    error: function (result) {
                        toastr.warning("Se produjo un error al intentar realizar el movimiento entre depósitos.");
                    }
                });
            });
        });

        function isValidExchange()
        {
            if ($("#OriginDepositId").val() == $("#DestinyDepositId").val())
            {
                toastr.warning("El depósito de orígen y destino deben ser distintos.");
                return false;
            }
            if ($("#ColorId option:selected").data("stock") < $("#Quantity").val())
            {
                toastr.warning("La cantidad ingresada es mayor a la existente.");
                return false;
            }
            return true;
        }

        function toggleModal(frm) {
            $("#" + frm).modal('toggle');
        }

        function GetProductSizes()
        {
            if ($("#ProductId").val() != '')
            {
                $.ajax({
                    type: "GET",
                    cache: false,
                    url: "/Products/GetProductSizesToSale",
                    data: { ProductId: $("#ProductId").val() },
                    success: function (data)
                    {
                        control = $("#SizeId");
                        control.empty();
                        control.select2();

                        control.append($('<option value="">Talle</option>'));
                        $.each(data, function (index, item) {
                            control.append($('<option value=' + item.SizeId + '>' + item.Description + '</option>'));
                        });

                        control = $("#ColorId");
                        control.empty();
                        control.select2();
                    }
                });
            }
            else if($("#ProductId_sm").val() != '')
            {
                if ($("#MovementType").val() == "@((int)StockMovementTypeEnum.Egreso)") {
                    $.ajax({
                        type: "GET",
                        cache: false,
                        url: "/Products/GetProductSizesToSale",
                        data: { ProductId: $("#ProductId_sm").val() },
                        success: function (data) {
                            control = $("#SizeId_sm");
                            control.empty();
                            control.select2();

                            control.append($('<option value="">Talle</option>'));
                            $.each(data, function (index, item) {
                                control.append($('<option value=' + item.SizeId + '>' + item.Description + '</option>'));
                            });

                            control = $("#ColorId_sm");
                            control.empty();
                            control.select2();
                        }
                    });
                } else {
                    $.ajax({
                        type: "GET",
                        cache: false,
                        url: "/Products/GetProductSizesToSale",
                        data: { },
                        success: function (data) {
                            control = $("#SizeId_sm");
                            control.empty();
                            control.select2();

                            control.append($('<option value="">Talle</option>'));
                            $.each(data, function (index, item) {
                                control.append($('<option value=' + item.SizeId + '>' + item.Description + '</option>'));
                            });

                            control = $("#ColorId_sm");
                            control.empty();
                            control.select2();
                        }
                    });
                }
            }
        }

        function GetProductSizeColors()
        {
            if ($("#SizeId").val() != '')
            {
                $.ajax({
                    type: "GET",
                    cache: false,
                    url: "/Products/GetProductColorsToSale",
                    data: { ProductId: $("#ProductId").val(), SizeId: $("#SizeId").val() },
                    success: function (data) {
                        control = $("#ColorId");
                        control.empty();
                        control.select2();

                        control.append($('<option value="">Color</option>'));
                        $.each(data, function (index, item) {
                            control.append($('<option value="' + item.ColorId + '" data-stock="' + item.StockReal + '">' + item.Description + ' [' + item.StockReal + ']</option>'));
                        });
                    }
                });
            } else if ($("#SizeId_sm").val() != '') {
                if ($("#MovementType").val() == "@((int)StockMovementTypeEnum.Egreso)")
                {
                    $.ajax({
                        type: "GET",
                        cache: false,
                        url: "/Products/GetProductColorsToSale",
                        data: { ProductId: $("#ProductId_sm").val(), SizeId: $("#SizeId_sm").val() },
                        success: function (data) {
                            control = $("#ColorId_sm");
                            control.empty();
                            control.select2();

                            control.append($('<option value="">Color</option>'));
                            $.each(data, function (index, item) {
                                control.append($('<option value="' + item.ColorId + '" data-stock="' + item.StockReal + '">' + item.Description + ' [' + item.StockReal + ']</option>'));
                            });
                        }
                    });
                } else {
                    $.ajax({
                        type: "GET",
                        cache: false,
                        url: "/Products/GetProductColorsToSale",
                        data: {  },
                        success: function (data) {
                            control = $("#ColorId_sm");
                            control.empty();
                            control.select2();

                            control.append($('<option value="">Color</option>'));
                            $.each(data, function (index, item) {
                                control.append($('<option value="' + item.ColorId + '" data-stock="' + item.StockReal + '">' + item.Description + ' [' + item.StockReal + ']</option>'));
                            });
                        }
                    });
                }
                
            }

        }

        function cleanFormInputs(formName)
        {
            $("#" + formName).find("input[type=text], textarea, select").val('');
            $("#" + formName).find("select[data-plugin*='select2']").select2();

            $("#" + formName).data('formValidation').resetForm();
        }

    </script>

}

